﻿Type=Class
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
Sub Class_Globals
	Dim M_MarketName As String   'Guarda el nombre del Mercado
	Dim M_Initialized As Boolean 'Si el objeto de a inicializado
	Dim M_IsActive As Boolean    'Si la toma de datos no a tenido errores TRUE. Si ha fallado se desactivo este mercado FALSE
	Dim M_Type As String         'Tipo de libro a administrar
	
	Dim M_Now As Double          'Guarda el valor actual que necesito
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(MarketName As String)
	M_MarketName = MarketName
	M_Initialized = True
	M_IsActive = True
End Sub

'Solicita el libro
Public Sub GetOrderBook(tipo As String, Depth As Long)
	M_Type = tipo    'tipo de libro
	
	Try
		If(M_Initialized)Then
			If(M_IsActive)Then
				Dim url As String
				url = "https://bittrex.com/api/v1.1/public/getorderbook?market=" & "BTC-" & M_MarketName & "&type=" & M_Type & "&depth=" & Depth
				SendCommand("GetOrderBook", url)
			End If
		End If
	Catch
		ToastMessageShow("OrderBook.getOrderBook: " & LastException, True)
	End Try
End Sub

private Sub SendCommand(work As String, url As String)
	Try
		Dim nonce As Long
		nonce = DateTime.now
	
		url = url & "&nonce=" & nonce    'Hay que añadir la hora (en ticks) de la solicitud
	
		Dim sign() As Byte
		sign = function.HashHmac( url, function.GetApiSecret)   'Firmo la url
	
		Dim API_Signed As String
		Dim Byte_Conv As ByteConverter
		API_Signed = Byte_Conv.HexFromBytes(sign) 'convert to HEX
		API_Signed = API_Signed.ToLowerCase
	
		Dim j As HttpJob

		j.Initialize(work, Me)
		j.PostString(url, "")
		j.GetRequest.SetHeader("apisign", API_Signed)
	Catch
		ToastMessageShow("market.SendCommand"&LastException, True)
	End Try
End Sub

private Sub jobDone (job As HttpJob)
	Try
		If (job.Success) Then
			If (job.JobName == "GetOrderBook") Then
				Dim parser As JSONParser
				parser.Initialize(job.GetString)
				Dim root As Map = parser.NextObject
				Dim result As List = root.Get("result")
				
				'Creo la lista aquí, para que al finalizar la funcion, la memoria se libere.
				Dim ListOrden As List				
				
				'Inicializo la lista
				ListOrden.Initialize
				
				For Each colresult As Map In result
					
					'Cada dato tiene un valor y una cantidad
					Dim Rate As Double = function.Str2double(colresult.Get("Rate"))
					Dim Quantity As Double = function.Str2double(colresult.Get("Quantity"))
					
					'Creo las variables aqui
					Dim Orden As orden
					Orden.Initialize						
					Orden.Rate = Rate
					Orden.Quantity = Quantity
						
					'Guardo la variable en la lista
					ListOrden.Add(Orden)
				Next
				
				'Ordeno la lista segun requiera
				
				'Ordenar
				If (M_Type == "buy") Then
					ListOrden.SortType("Rate", False)
				End If
				
				'Ordenar
				If (M_Type == "sell") Then
					ListOrden.SortType("Rate", True)
				End If
				
				' Me intereza solo el primer elemento de la lista.
				Dim Orden As orden
				Orden.Initialize				
				Orden = ListOrden.get(0)
				
				'Si no han habido problemas, guardamos el dato requerido en un variable,
				If M_IsActive Then
					M_Now = Orden.Rate ' Guardo por ahora solo el Rate. Cuando el programa avance
					                   ' guardo también el dato Quantity
				End If				
				
				'Dim success As String = root.Get("success")
				'Dim message As String = root.Get("message")
			End If
		End If
		
		'Si no hay problemas se puede recibir nueva información
		M_IsActive = True
	Catch
		Log(LastException)
		ToastMessageShow("Orderbook.jobDone" & M_MarketName & LastException, True)
		
		'Si hay problemas. No se almacena nueva información
		M_IsActive = False
	End Try
End Sub

Public Sub GetNow As Double
	Return M_Now
End Sub
