﻿Type=Service
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Dim MarketName As String       'Nombre del Mercado
	
	Dim OrderBuy As OrderBook      'Objeto encargado de facilitar el manejo de libro de compras
	Dim OrderSell As OrderBook     'Objeto encargado de facilitar el manejo de libro de ventas
	
	Dim SaveData As db             'Objeto encargado de administrar la base de datos.
	
	Dim n As Notification          'Para las notificaciones
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	Try
		MarketName = "DASH"                 'Mercado a monitorear
		
		OrderBuy.Initialize(MarketName)     'Inicializamos el libro de compras
		OrderSell.Initialize(MarketName)    'Inicializamos el libro de ventas
		
		SaveData.Initialize("BittrexDB.db") 'Inicializamos la base de datos
	
		'Configuramos las notificaciones.
		n.Initialize
		n.Insistent = False           
		n.Sound = False               'No sonido. Para que no moleste
		n.Vibrate = False             'No vibración. Para que no moleste
		n.Icon = "icon"
		n.AutoCancel = True
		
		'Definimos que la aplicacion inicia guardando datos
		Main.Stop = False
	Catch
		Log(LastException)
	End Try
End Sub

Sub Service_Start (StartingIntent As Intent)
	Try
		OrderBuy.GetOrderBook("buy", 50)     'Este libro de compras se encargará de recibir datos de el libro de compras con una profuncidad en el mismo de 50
		OrderSell.GetOrderBook("sell", 50)   'Este libro de compras se encargará de recibir datos de el libro de ventas con una profuncidad en el mismo de 50
		
		Main.Buy = OrderBuy.GetNow           'Obtenenos el mayor valor al que nos compran
		Main.Sell = OrderSell.GetNow         'Obtenenos el menor valor al que podemos comprar
		
		'Intentamos guardar los datos
		Dim time As Long                     'Esta variable guarda los Ticks en el momento que se guardo el registro. Se emplea para verificar si el dato registrado se guardo realmente  
		time = SaveData.Insert(MarketName, Main.Buy, Main.Sell)
		
		'Cuenta los registros y almacena el dato en la variable 'registros' en el Main
		SaveData.Count
		
		'Muestra cuantos registros se han guardado
		n.SetInfo("Bittrex", "Datos: " & Main.Registros, Main)
		n.Notify(1)
		
		'Mientras Stop sea Falso se debe ejecutar de nuevo para guardar otro dato
		If Main.Stop == False Then
			StartServiceAt(Me, (DateTime.now + 1000 * 5), True) 'Recibe datos cada 5 segundos.
		End If
	Catch
		Log(LastException)
	End Try
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
